Subject: Re: [DNSOP] Fwd: New Version Notification for draft-hoffman-dns-terminology-00.txt

From: Willem Toorop <[email-masked]>
Date: Mon, 23 Feb 2015 15:06:28 +0100

Maybe this document can give a decisive answer on the expansion of AXFR
as well?  In the RFC Editor Abbreviations List (
https://ftp.rfc-editor.org/rfc-style-guide/abbrev.expansion.txt ), this
is expanded as either     - Asynchronous Full Transfer (AXFR)  or
           - Authoritative Transfer             or
           - full zone transfer (AXFR) (RFC 6168)

Op 28-11-14 om 16:28 schreef Paul Hoffman:
> Greetings. Andrew and Kazunori and I have prepared the first draft of what will hopefully be a useful document collecting definitions that useful in the DNS community. We fully admit that this is quite rough, and didn't even try to do definitions for some of the terms that we expect to be filled in before we are done.
> 
> The idea is that this will be an IETF consensus document, if possible, but we are not yet asking for adoption in the DNSOP WG, and we might not even later. For now, we'd like to hear what additional terms should be added, what clarifications to the terms we already have would be helpful, and so on.
> 
> --Paul Hoffman
> 
>> A new version of I-D, draft-hoffman-dns-terminology-00.txt
>> has been successfully submitted by Paul Hoffman and posted to the
>> IETF repository.
>>
>> Name:		draft-hoffman-dns-terminology
>> Revision:	00
>> Title:		DNS Terminology
>> Document date:	2014-11-28
>> Group:		Individual Submission
>> Pages:		9
>> URL:            http://www.ietf.org/internet-drafts/draft-hoffman-dns-terminology-00.txt
>> Status:         https://datatracker.ietf.org/doc/draft-hoffman-dns-terminology/
>> Htmlized:       http://tools.ietf.org/html/draft-hoffman-dns-terminology-00
>>
>>
>> Abstract:
>>   The DNS is defined in literally dozens of different RFCs.  The
>>   terminology used in by implementers and developers of DNS protocols,
>>   and by operators of DNS systems, has sometimes changed in the decades
>>   since the DNS was first defined.  This document gives current
>>   definitions for many of the terms used in the DNS in a single
>>   document.
> 
> _______________________________________________
> DNSOP mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dnsop
>

---

From: Ray Bellis <[email-masked]>
Date: Mon, 23 Feb 2015 14:15:05 +0000

> On 23 Feb 2015, at 14:06, Willem Toorop <[email-masked]> wrote:
> 

Where on earth did "Asynchronous" come from in that first expansion?!

It's not mentioned anywhere in 1034 or 1035 

Ray

---

From: Willem Toorop <[email-masked]>
Date: Mon, 23 Feb 2015 15:36:17 +0100

> Where on earth did "Asynchronous" come from in that first expansion?!

Who knows, but it appears frequently used like this outside the IETF
(google yourself).  It made me wonder what is cause and what is
consequence.  Is it in the rfc style guide because it is used so
frequently?  Or is it used like this because it is in the style guide?

> It's not mentioned anywhere in 1034 or 1035 

Neither is authoritative transfer...
...but mention frequently like this in other rfcs yes.

-- Willem

---

From: Paul Hoffman <[email-masked]>
Date: Mon, 23 Feb 2015 07:09:23 -0800

The relevant RFC, 5936, says that the mnemonic means "Authoritative Transfer", both in the abstract and introduction.

--Paul Hoffman

---

From: "Darcy Kevin (FCA)" <[email-masked]>
Date: Mon, 23 Feb 2015 17:46:17 +0000

"Asynchronous" makes no sense to me. In what way is an AXFR "asynchronous"?

"Authoritative transfer"? As opposed to what? Non-authoritative transfer? "Authoritative" seems rather redundant in that phrase -- AXFRs are always comprised of authoritative data, aren't they?

The reference to "full zone transfer" in RFC 6168 doesn't appear to be an attempt to explain the acronym; it's just a reference to the mechanism. Plus -- to state the obvious -- there is no "a" in the word "full".

I did a little RFC spelunking, and the earliest reference I could find to AXFR is (obsolete) RFC 883, where QTYPE 252 is defined as " A request for a transfer of an entire zone of authority". So, this is circumstantial evidence that the "A" in "AXFR" actually stands for "Authority", and this complements the meaning of "A" in "SOA" (which I've always thought would have been better called a zone "header" or "control", as in "control record" for the zone). Back in those days, the concept of a zone seemed to be of a blob of "authority" stuff, not necessarily defined within a separate file or as a separate element of the nameserver config, which could nevertheless be treated as a single administrative/operational unit for purposes of delegation, replication, etc. It wasn't until later that "zone" became a full-fledged concept in its own right, with "authoritativeness" of its data being presumed, thus all of the references to "authority" were seen as redundant and passed into relative disuse (at least, until DNSSEC came along and the distinction between authoritative and non-authoritative data became vitally important again).

But, is the question for this ID a) what was *intended* by the AXFR acronym, as a matter of IETF history, or b) what we *want* "AXFR" to mean *now*? If the latter, I vote for re-interpreting the "A" in "AXFR" as standing for "ancient" :-)

												- Kevin

-----Original Message-----
From: DNSOP [mailto:[email-masked]] On Behalf Of Willem Toorop
Sent: Monday, February 23, 2015 9:06 AM
To: [email-masked]
Subject: Re: [DNSOP] Fwd: New Version Notification for draft-hoffman-dns-terminology-00.txt

Maybe this document can give a decisive answer on the expansion of AXFR as well?  In the RFC Editor Abbreviations List ( https://ftp.rfc-editor.org/rfc-style-guide/abbrev.expansion.txt ), this
is expanded as either     - Asynchronous Full Transfer (AXFR)  or
           - Authoritative Transfer             or
           - full zone transfer (AXFR) (RFC 6168)

---

From: "John Levine" <[email-masked]>
Date: 24 Feb 2015 01:46:34 -0000

>"Asynchronous" makes no sense to me. In what way is an AXFR "asynchronous"?

I suspect someone who didn't understand DNS very well said that once
in a paper or meeting or web page, and it spread cargo-cult style
across the Internet.

"Authoritative" makes sense.

R's,
John

---

From: Paul Vixie <[email-masked]>
Date: Mon, 23 Feb 2015 18:09:20 -0800

> John Levine <mailto:[email-masked]>
> Monday, February 23, 2015 5:46 PM
>

in the sense that the transfer occurs asynchronous to query/response
transactions, and given that the hated [RFC1035 4.2.2] contains the
words, "The server should not block other activities waiting for TCP
data", i think we could pretend that "A" stood for "asynchronous" or
anything else we wanted, at this late stage of the game. consider also
this [ibid] text:

> 6.3. Zone refresh and reload processing
> ...
> If a master is sending a zone out via AXFR, and a new version is created
> during the transfer, the master should continue to send the old version
> if possible.  In any case, it should never send part of one version and
> part of another.  If completion is not possible, the master should reset
> the connection on which the zone transfer is taking place.

which purposely and explicitly makes the zone transfer process asynchronous from any query/response stream. 

however, AXFR was never an acronym, and there is no original meaning to
be discovered here. in [RFC1035 3.2.3] there is one line of text:

> AXFR            252 A request for a transfer of an entire zone

and it's the definition of the QTYPE, not the overall transaction that
the QTYPE is part of.

i think the safest thing is to not invent an acronym, but rather, let
the QTYPE definition stand as written.

-- 
Paul Vixie

---

From: Edward Lewis <[email-masked]>
Date: Tue, 24 Feb 2015 14:28:14 +0000

And there’s http://www.rfc-editor.org/rfc/rfc5936.txt.  It has
"Authoritative Transfer (AXFR)” in the abstract.

“Asynchronous" does not appear in that RFC.

(In the “not that it matters, but” file: When we had singly threaded name
servers, AXFR wasn’t very asynchronous in practice.)

(Sorry, I can’t get the message indentation to work in Outlook, so I hacked
this up:)

On 2/23/15, 21:09, "Paul Vixie" <[email-masked]> wrote:

>> > i think we could pretend that "A" stood for "asynchronous" or anything else
>> we wanted, … i think the safest thing is to not invent an acronym, but
>> rather, let the QTYPE definition stand as written.

---

From: Edward Lewis <[email-masked]>
Date: Tue, 24 Feb 2015 14:30:00 +0000

Sorry, I was reading the mail list asynchronously and found this after I
sent my note on 5936.

;)

On 2/23/15, 10:09, "Paul Hoffman" <[email-masked]> wrote:

>The relevant RFC, 5936, says that the mnemonic means "Authoritative
>Transfer", both in the abstract and introduction.
>
>--Paul Hoffman

---

From: Shumon Huque <[email-masked]>
Date: Tue, 24 Feb 2015 11:33:32 -0500

Paul Vixie:
>
> however, AXFR was never an acronym, and there is no original meaning
> to be discovered here. in [RFC1035 3.2.3] there is one line of text:
>

This is my feeling too. These backbending attempts to retrofit an
appropriate expansion of the abbreviation seem a bit strange to me.
Not all abbreviations need to be able spell out every letter in them.

(Also, I'm not sure this is commonly accepted by grammarians, but I've
been trained by English major friends to not call these things acronyms,
which I'm told are the subset of "pronounceable abbreviations" like ASCII
and NAT).

> “Asynchronous" does not appear in that RFC.

Hmm, does this imply that IXFR is a transfer of data that it not
authoritative? :-) Or does it need to be renamed to IAXFR.

Or should A in AXFR be something else, like "Absolute", or "All" or
"All-Data" which might more correctly differentiate it from "Incremental".

Shumon Huque

---

From: Edward Lewis <[email-masked]>
Date: Tue, 24 Feb 2015 16:59:32 +0000

> authoritative? :-) Or does it need to be renamed to IAXFR.

I have a shovel out back, want to borrow it?

> "All-Data" which might more correctly differentiate it from "Incremental".

Seriously - in operations land, "what you call something" isn’t as important
as the term’s definition being clear and common.

The only time one should fix documentation land is when trying to achieve a
clear and common understanding is had too difficult without the fix.

To quote a scholarship fund “A mind is a terrible thing to waste.”  In the
same sense, I’d rather see effort spent improving operations than fixing
words.

(Not referring to -dns-terminology-, referring to worrying about the precise
definition of the “A” in AXFR.)

---

From: Shumon Huque <[email-masked]>
Date: Tue, 24 Feb 2015 12:07:08 -0500

> Seriously - in operations land, "what you call something" isn’t as
important as the term’s definition being clear and common.

I agree, Ed.

I was mostly joking with that suggestion - I thought that was clear
from my earlier paragraph that you didn't quote where I said I found
it a bit pointless to retrofit new abbreviation expansions. The
definition is what it is!

Shumon Huque

---

From: Edward Lewis <[email-masked]>
Date: Tue, 24 Feb 2015 17:11:05 +0000

On 2/24/15, 12:07, "Shumon Huque" <[email-masked]> wrote:
> I thought that was clear
> from my earlier paragraph that you didn't quote

 Proves that I only read what I want to read. ;)

I didn’t think you seriously wanted to borrow the shovel.

---

From: Mark Andrews <[email-masked]>
Date: Wed, 25 Feb 2015 06:28:08 +1100

In message <[email-masked].
net>, "Darcy Kevin (FCA)" writes:
> "Authoritative transfer"? As opposed to what? Non-authoritative transfer? "Author
> itative" seems rather redundant in that phrase -- AXFRs are always comprised of a
> uthoritative data, aren't they?

You are transfering the data you are supposed to be authoritative for which make
it a "Authority Transfer" or "Authoritative Data Transfer".

Mark
-- 
Mark Andrews, ISC
1 Seymour St., Dundas Valley, NSW 2117, Australia
PHONE: +61 2 9871 4742                 INTERNET: [email-masked]